<?php

namespace Teknisa\EST\Modules\Produto\Controllers;

use \Zeedhi\Framework\DTO\Request;
use \Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;

class EstruarvoreprodArvore extends \Teknisa\EST\Controllers\TeknisaCrud{

	protected $dataSourceName = 'estruarvoreprod_para_arvore';

	public function find(Request\Filter $request, Response $response){
		$filterCriteria = $request->getFilterCriteria();
        $conditions     = $filterCriteria->getConditions();

        parent::find($request, $response);

        $dataSets = $response->getDataSets();
        if (count($dataSets) > 0) {
            $rows = $dataSets[0]->getRows();

            $rows = array_map(function($row) {
                $row['_hasChild'] = $row['HASCHILD'] === 'true' ? true : false;
                unset($row['HASCHILD']);
                return $row;
            }, $rows);

            $response->setDataSets(array(new DataSet('estruarvoreprod_para_arvore', $rows)));
        }
        
	}
}