<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\Repositories;

class EsoNaoperiodico extends \Doctrine\ORM\EntityRepository {
    
    public function getEnviosEvento($nrorg, $nmevento, $nrestruturam, $nrtpambiente, $nrvinculom, $idativo = 'S', $nrchave = null, $nrtabela = null, $idoperacao = array(), $nrenvioexcl=null) {
        try{
            $esoNaoperiodico = Repositories::ESO_NAOPERIODICO;
            $esoEvento = Repositories::ESO_EVENTO;
            
            $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
            $params = array(
                'nrorg' => $nrorg,
                'nmevento' => $nmevento,
                'nrestruturam' => $nrestruturam,
                'nrtpambiente' => $nrtpambiente,
                'nrvinculom' => $nrvinculom,
                'idativo' => $idativo,
                'nrchave' => $nrchave,
                'nrtabela' => $nrtabela,
                'nrenvioexcl' => $nrenvioexcl,
            );
            $sql = "SELECT envio
                      FROM $esoNaoperiodico envio
                     WHERE envio.nrorg = :nrorg
                       AND envio.nmevento = :nmevento
                       AND (envio.nrestruturam = :nrestruturam OR (envio.nrestruturam <> :nrestruturam AND envio.nmevento IN ('S-2205','S-2206','S-2306'))) 
                       AND envio.nrtpambiente = :nrtpambiente
                       AND envio.nrvinculom = :nrvinculom
                       AND envio.idativo = :idativo
                       AND (envio.nrchave = :nrchave OR :nrchave IS NULL)
                       AND (envio.nrtabela = :nrtabela OR :nrtabela IS NULL)
                       AND ((:nrenvioexcl = 'S' AND envio.nrenvioexcl IS NOT NULL) OR (:nrenvioexcl = 'N' AND envio.nrenvioexcl IS NULL) OR :nrenvioexcl IS NULL)";
            
            if (!empty($idoperacao)) {
                $sql .= " AND (envio.idoperacao IN ('".implode("','",$idoperacao)."'))";
            }
           
            return $this->getEntityManager()->createQuery($sql)->execute($params);
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function getEnvioAdmissaoVinculo($nrorg, $nrtpambiente, $cdcnpjempregador, $nrvinculom, $dtmescompetenc) {
        try{
            $esoNaoperiodico = Repositories::ESO_NAOPERIODICO;
            $estruturah = Repositories::ESTRUTURAH;
            
            $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
            $params = array(
                'nrorg' => $nrorg,
                'nrtpambiente' => $nrtpambiente,
                'cdcnpjempregador' => $cdcnpjempregador,
                'nrvinculom' => $nrvinculom,
                'dtmescompetenc' => $dtmescompetenc,
            );
            $sql = "SELECT envio
                      FROM $esoNaoperiodico envio
                      JOIN $estruturah evh WITH evh.nrorg = envio.nrorg
                                            AND evh.nrestruturam = envio.nrestruturam
                                            AND SUBSTRING(evh.cdcnpjestrut,1,8) = SUBSTRING(:cdcnpjempregador,1,8)
                                            AND evh.dtmescompetenc = (SELECT MAX(h1.dtmescompetenc) FROM $estruturah h1
                                                                       WHERE h1.nrorg = evh.nrorg
                                                                         AND h1.nrestruturam = evh.nrestruturam
                                                                         AND h1.dtmescompetenc <= :dtmescompetenc)
                     WHERE envio.nrorg = :nrorg
                       AND envio.nrtpambiente = :nrtpambiente
                       AND envio.nrvinculom = :nrvinculom
                       AND envio.nmevento IN ('S-2200','S-2300')
                       AND envio.idativo = 'S'
                       AND envio.nrenvioexcl IS NULL
                     ORDER BY envio.dtmescompetenc DESC";
           
            return $this->getEntityManager()->createQuery($sql)->execute($params);
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function getEnvioRescisaoVinculo($nrorg, $nrtpambiente, $cdcnpjempregador, $nrvinculom, $dtmescompetenc) {
        try{
            $esoNaoperiodico = Repositories::ESO_NAOPERIODICO;
            $estruturah = Repositories::ESTRUTURAH;
            
            $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
            $params = array(
                'nrorg' => $nrorg,
                'nrtpambiente' => $nrtpambiente,
                'cdcnpjempregador' => $cdcnpjempregador,
                'nrvinculom' => $nrvinculom,
                'dtmescompetenc' => $dtmescompetenc,
            );
            $sql = "SELECT envio
                      FROM $esoNaoperiodico envio
                      JOIN $estruturah evh WITH evh.nrorg = envio.nrorg
                                            AND evh.nrestruturam = envio.nrestruturam
                                            AND SUBSTRING(evh.cdcnpjestrut,1,8) = SUBSTRING(:cdcnpjempregador,1,8)
                                            AND evh.dtmescompetenc = (SELECT MAX(h1.dtmescompetenc) FROM $estruturah h1
                                                                       WHERE h1.nrorg = evh.nrorg
                                                                         AND h1.nrestruturam = evh.nrestruturam
                                                                         AND h1.dtmescompetenc <= :dtmescompetenc)
                     WHERE envio.nrorg = :nrorg
                       AND envio.nrtpambiente = :nrtpambiente
                       AND envio.nrvinculom = :nrvinculom
                       AND envio.nmevento IN ('S-2299','S-2399')
                       AND envio.idativo = 'S'
                       AND envio.nrenvioexcl IS NULL
                     ORDER BY envio.dtmescompetenc DESC";
           
            return $this->getEntityManager()->createQuery($sql)->execute($params);
        } catch (Exception $e) {
            throw $e;
        }
    }
}