var Est97000_PercentualDivergenciasInventarioCego_Controller = function(templateManager, ScreenService, MessageService, General, EstUtil, ZhFilterPreferences, Est97000_PercentualDivergenciasInventarioCego_Services) {

    // Open initial screen filter with default values
    this.onOpenFilter = function(widget) {
        let rowsToSet = {};
        Est97000_PercentualDivergenciasInventarioCego_Services.getFilialLogada().then(success => {
            const { NMFILIAL, CDFILIAL } = success.dataset.filial[0];
            rowsToSet.NMFILIAL = NMFILIAL;
            rowsToSet.CDFILIAL = CDFILIAL;

            ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(() => {
                templateManager.container.getActiveWidget('zhFilterPreferencesSelectConditions').getField("NMFILIAL").reload();
            });
        });
    };

    // This function creates a new currentRow with default values
    this.onAddProducts = function(widget) {
        if (EstUtil.onValidateFilterRequirement(widget,true)) return;
        widget.currentRow.CDFILIAL = EstUtil.getFieldValue('CDFILIAL', 'MainWidget', true);
    };

    // It saves products
    this.onSaveProducts = function(widget) {
        if (!widget.isValid()) return;

        if (widget.name == 'MainWidget') {
            EstUtil.saveCrud(widget).then(() => {
                ScreenService.closeSwipe();
                widget.list();
                widget.reload();
                MessageService.successNotificationByCode('REGISTER_SUCCESS');
            });
        }
        else {
            Est97000_PercentualDivergenciasInventarioCego_Services.onCheckDataset(widget.currentRow).then((dataSet) => {
                EstUtil.saveDataSetCrud(dataSet, 'parperdivestceg').then(() => {
                    widget.currentRow = [];
                    this.onClosePopUp(widget);
                    MessageService.successNotificationByCode('AUTO_REGISTER_SUCCESS');
                });
            });
        }
    };

    // It opens auto register pop up
    this.onOpenPopUp = function() {
        const PopUpAutoRegister = templateManager.container.getWidget('AutoRegisterPopUp');
        ScreenService.openPopup(PopUpAutoRegister);
    };

    // It closes auto register pop up and reactivate main widget
    this.onClosePopUp = function() {
        const MainWidget = templateManager.container.getWidget('MainWidget');
        ScreenService.closePopup();
        MainWidget.activate();
        MainWidget.reload();
    };

};

Configuration(function(ContextRegister) {
    ContextRegister.register('Est97000_PercentualDivergenciasInventarioCego_Controller', Est97000_PercentualDivergenciasInventarioCego_Controller);
});
